#pragma once
#include <semaphore.h>
#include <errno.h>
#include <stdlib.h>

//-----------------------------------------------------------------------------
/**
@brief セマフォ
*/
class SGSemaphore
{
public:
	SGSemaphore();
	virtual ~SGSemaphore();
	
	void Lock();
	int TryLock();
	int Unlock();
	int GetAndDecrementCounter(int val=1);
	int Increment(int val=1);
	int Decrement(int val=1);

private:
	sem_t mSemaphore;      ///< @brief セマフォ
	volatile int mCounter; ///< @brief カウンタ
};

